

from threading_cleanup import *
import random

class LockerRoom:
    def __init__(self):
        #don't use occupants in your solution
        self.occupants = []
        self.mutex = Semaphore(1)

    def enter(self, gender):
        self.mutex.wait()
        self.occupants.append(gender)
        print self.occupants
        self.mutex.signal()

    def leave(self, gender):
        self.mutex.wait()
        self.occupants.remove(gender)
        print self.occupants
        self.mutex.signal()

def male(lockerRoom):
    lockerRoom.enter('male')
    time.sleep(random.random() / 2)
    lockerRoom.leave('male')

def female(lockerRoom):
    lockerRoom.enter('female')
    time.sleep(random.random() / 2)
    lockerRoom.leave('female')

def loop(lockerRoom, f, mu=1):
    while True:
        t = random.expovariate(1.0/mu)
        time.sleep(t)
        f(lockerRoom)

lockerRoom = LockerRoom()
fs = [male]*5 + [female]*5 
threads = [Thread(loop, lockerRoom, f) for f in fs]
for thread in threads: thread.join()

